//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package nc.bs.arap.actions;

import nc.bs.arap.bill.ArapBillPubUtil;
import nc.bs.arap.util.ArapBillVOUtils;
import nc.bs.arap.util.BillAccountCalendarUtils;
import nc.bs.arap.util.BillDateUtils;
import nc.bs.arap.util.BillMoneyVUtils;
import nc.bs.arap.validator.CrossRuleCheckValidator;
import nc.bs.dao.BaseDAO;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.arap.basebill.BaseBillVO;
import nc.vo.arap.gathering.GatheringBillItemVO;
import nc.vo.arap.utils.StringUtil;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDouble;

import java.util.Map;

public class GatheringbillSaveBatchBSAction extends BillInsertBatchBSAction {
    public GatheringbillSaveBatchBSAction() {
        this.validatorCode.add(5);
        this.validatorCode.add(15);
        this.validatorCode.add(29);
        this.validatorCode.add(19);
        this.validatorCode.add(8);
        this.validatorCode.add(24);
        this.validatorCode.add(28);
//        this.validatorCode.add(44);
        this.validatorCode.add(46);
        this.validatorCode.add(31);
        this.validatorCode.add(36);
        this.validatorCode.add(23);
        this.validatorCode.add(49);
        this.validatorCode.add(57);
        this.validatorCode.add(59);
        this.validatorCode.add(62);
        this.validatorCode.add(93);
        this.validatorCode.add(94);
        this.validatorCode.add(100);
    }

    protected void doBeforeInsert(AggregatedValueObject[] bills) throws BusinessException {
        ArapBillPubUtil.fillTradeTypeInfo(bills);
        BillDateUtils.setBillDateByNow(bills);
        ArapBillPubUtil.resetBasedocVid(bills);
        BillAccountCalendarUtils.setAccperiodYearMonth(bills);
        ArapBillVOUtils.prepareDefaultInfo(bills);
        BillMoneyVUtils.sumAllVoBodyToHead(bills);
        (new CrossRuleCheckValidator()).validate(bills);
        ArapBillPubUtil.resetDestVODoc(bills);
        ArapBillVOUtils.setMaterialInfo(bills);
        ArapBillVOUtils.setDefaultSagaFrozen(bills);
        ArapBillVOUtils.setDefaultFeeundertaker(bills);
        ArapBillVOUtils.setDefaultSettleFlag(bills);

        /**
         * 收款单保存校验关联的销售订单实际收款金额是否超过价税合计
         */

        for(AggregatedValueObject bill : bills) {
            BaseBillVO billVO = (BaseBillVO) bill.getParentVO(); //修改的收款单
            UFDouble money = billVO.getMoney(); //金额
            String pk_tradetype = billVO.getPk_tradetype();
//            if(!"F2-Cxx-02".equals(pk_tradetype)){
//                continue;
//            }
            String srcBilltype = ((GatheringBillItemVO)bill.getChildrenVO()[0]).getSrc_billtype();
            if(!"30".equals(srcBilltype)){
                continue;
            }
            String def3 = ((GatheringBillItemVO)bill.getChildrenVO()[0]).getSrc_billid(); // 收款单对应的销售订单id
            if(StringUtil.isEmpty(def3) || "N".equals(def3) || "~".equals(def3)){
                //无绑定的销售订单则下一次循环
                continue;
            }

            //根据销售订单id去查询销售订单
            BaseDAO dao = new BaseDAO();
            String sql = "select vbillcode,nreceivedmny,ntotalorigmny from so_saleorder where dr = 0 and csaleorderid = '" +def3+"'";

            Map saleMap = (Map)dao.executeQuery(sql, new MapProcessor());
            //销售订单价税合计
            UFDouble ntotalorigmny = UFDouble.ZERO_DBL;
            //销售订单实际收款金额
            UFDouble nreceivedmny = UFDouble.ZERO_DBL;
            String vbillcode = "";
            if(saleMap != null) {
                nreceivedmny = new UFDouble(saleMap.get("nreceivedmny") == null ? "0" : saleMap.get("nreceivedmny").toString());
                ntotalorigmny = new UFDouble(saleMap.get("ntotalorigmny") == null ? "0" : saleMap.get("ntotalorigmny").toString());
                vbillcode = saleMap.get("vbillcode") == null ? "" : saleMap.get("vbillcode").toString();
            }
            if (money.compareTo(ntotalorigmny) > 0) {
                UFDouble moreMoney = money.sub(ntotalorigmny);
                throw new BusinessException("【该笔收款税收合计" + money + "已超销售订单 [" + vbillcode + "] " + moreMoney + "元，无法传输！请检查订单累计收款金额！】");
            }
        }
    }
}
